extends Node



var menbros = {
	'null':{
		'img':null,
		'name':'null',
	},
	'braco_bruto':{
		'img':load("res://sprite/menbros/BracoBruto.png"),
		'range': 0.75,
		'dmg':1.25,
		'atkspeed':1.0,
		'upgrade': {'dmg':0.15},
		'name':'braco_bruto',
	},
	'menbro_chicote':{
		'img':load("res://sprite/menbros/MembroChicote.png"),
		'range': 1.25,
		'dmg':0.75,
		'atkspeed':1.25,
		'upgrade': {'atkspeed':0.1,'range':0.05},
		'name':'menbro_chicote',
	},
	'pernas_ligeiras':{
		'img':load("res://sprite/menbros/PatasLigeiras.png"),
		'hp': 0.75,
		'speed':1.75,
		'upgrade': {'speed':0.2},
		'name':'pernas_ligeiras',
	},
	'o_corredor':{
		'img':load("res://sprite/menbros/OCorredor.png"),
		'hp': 0.75,
		'dmg':0.75,
		'speed':2.0,
		'upgrade': {'speed':0.2},
		'name':'o_corredor',
	},
	'coxas_robustas':{
		'img':load("res://sprite/menbros/CoxasRobustas.png"),
		'hp': 1.25,
		'speed':1.25,
		'upgrade': {'speed':0.1, 'hp':0.1},
		'name':'coxas_robustas',
	},
	'patas_encourasadas':{
		'img':load("res://sprite/menbros/PataEncouracada.png"),
		'hp': 1.75,
		'speed':0.75,
		'upgrade': {'hp':0.2},
		'name':'patas_encourasadas',
	},
	'tentaculos_espinhosos':{
		'img':load("res://sprite/menbros/TentaculosEspinhosos.png"),
		'hp': 1.5,
		'dmg':1.5,
		'speed':0.5,
		'upgrade': {'hp':0.1, 'dmg':0.1},
		'name':'tentaculos_espinhosos',
	},
	'patas_perigosas':{
		'img':load("res://sprite/menbros/PatasPerigosas.png"),
		'dmg':1.5,
		'upgrade': {'dmg':0.2},
		'name':'patas_perigosas',
	},
	'garras_galantes':{
		'img':load("res://sprite/menbros/GarrasElegantes.png"),
		'hp': 1.25,
		'dmg':1.25,
		'upgrade': {'hp':0.1, 'dmg':0.1},
		'name':'garras_galantes',
	},
	'cutucao_relampago':{
		'img':load("res://sprite/menbros/CutucaoRelanpago.png"),
		'range': 0.75,
		'atkspeed':1.5,
		'dmg':0.75,
		'upgrade': {'atkspeed':0.15},
		'name':'cutucao_relampago',
	},
	'braco_arremesador':{
		'img':load("res://sprite/menbros/BracoArremessador.png"),
		'range': 1.25,
		'atkspeed':0.75,
		'dmg':1.0,
		'upgrade': {'dmg': 0.05, 'range': 0.1},
		'name':'braco_arremesador',
	},
	'membro_espigao':{
		'img':load("res://sprite/menbros/MembroEspigao.png"),
		'range': 1.0,
		'atkspeed':1.0,
		'dmg':1.0,
		'upgrade': {'atkspeed': 0.05, 'dmg': 0.05, 'range': 0.05},
		'name':'membro_espigao',
	}
}

var corpo = {
	'null':{
		'name':'null',
	},
	'carapaca_firme':{
		'hp':1.5,
		'upgrade': {'hp':0.1},
		'name':'carapaca_firme',
	},
	'metabolismo_avancado':{
		'regen':1.05,
		'regen_time':7.0,
		'upgrade': {'regen_time':-1.0},
		'name':'metabolismo_avancado',
	},
	'cerebro_avantajado':{
		'xpmult':1.25,
		'upgrade': {'xpmult':0.05},
		'name':'cerebro_avantajado',
	},
	'escama_reflexiva':{
		'react_dmg' : 1.0,
		'upgrade': {'react_dmg':0.2},
		'name':'escama_reflexiva',
	},
	'esqueleto_metalico':{
		'speed' : 0.5,
		'hp' : 2.0,
		'upgrade': {'hp':0.2},
		'name':'esqueleto_metalico',
	},
	'esqueleto_oco':{
		'speed' : 2.0,
		'hp' : 0.5,
		'upgrade': {'speed':0.2},
		'name':'esqueleto_oco',
	},
	'corpo_aerodinamico':{
		'speed' : 1.5,
		'upgrade': {'speed':0.2},
		'name':'corpo_aerodinamico',
	},
	'pernas_farpadas':{
		'atkspeed':1.2,
		'upgrade': {'atkspeed':0.04},
		'name':'pernas_farpadas',
	},
#	'carapaca_estpinhosa':{
#		'hp' : 1.2,
#		'name':'carapaca_estpinhosa',
#	},
	'estomago_duplo':{
		'hppickup' : 1.25,
		'upgrade': {'hppickup':0.1},
		'name':'estomago_duplo',
	},
	'carapa_instantanea':{
		'invunerabilitytime' : 2.5,
		'invunerabilitychance' : 1.15,
		'upgrade': {'invunerabilitychance':0.3, 'invunerability':0.5},
		'name':'carapa_instantanea',
	},
	'mordida_vampirica':{
		'hpsteal' : 0.05,
		'stealhp' : 0.1,
		'upgrade': {'stealhp': 0.02,'hpsteal' : 0.01,},
		'name':'mordida_vampirica',
	},
#	'camuflagen_natural':{
#		'detectionrage' : 0.8,
#		'name':'camuflagen_natural',
#	},
#	'intestino_glutao':{
#		'temphp' : 1.25,
#		'temphpmax' : 1.5,
#		'temphptime' : 5.00,
#		'name':'intestino_glutao',
#	},
#	'pele_reativa':{
#		'speedboost' : 1.15,
#		'speedboostpmax' : 1.3,
#		'speedboosttime' : 5.00,
#		'name':'pele_reativa',
#	},
	'olhos_admirantes':{
		'camzoom' : 1.5,
		'upgrade': {},
		'name':'olhos_admirantes',
	},
	'instinto_esquivador':{
		'invunerabilitychancemult' : 1.01,
		'upgrade': {},
		'name':'instinto_esquivador',
	},
	'espora_critica':{
		'critical_chance' : 1.1,
		'critical_dmg' : 2.0,
		'upgrade': {},
		'name':'espora_critica',
	},
}

var apendice = {
	'null':{
		'name':'null',
	},
#	'olhos_admirantes':{
#		'camzoom' : 1.5,
#		'name':'olhos_admirantes',
#	},
#	'audicao_apurada':{
#		'detection_enemy' : 1.0,
#		'name':'audicao_apurada',
#	},
#	'cauda_espinhosa':{
#		'backattack' : 5.0,
#		'name':'cauda_espinhosa',
#	},
#	'instinto_esquivador':{
#		'invunerabilitychancemult' : 1.01,
#		'name':'instinto_esquivador',
#	},
#	'espora_critica':{
#		'critical_chance' : 1.1,
#		'critical_dmg' : 2.0,
#		'name':'espora_critica',
#	},
#	'espora_toxica':{
#		'poison_chance' : 0.2,
#		'poison_dmg' : 0.1,
#		'name':'espora_toxica',
#	},
#	'espora_atordoante':{
#		'stun_chance' : 0.05,
#		'stun_time' : 1.00,
#		'name':'espora_atordoante',
#	},
#	'espora_surpresa':{
#		'sneak_dmg' : 2.00,
#		'name':'espora_surpres',
#	},
#	'visao_calor':{
#		'AoE_dmg' : 0.1,
#		'name':'visao_calor',
#	},
#	'antenas_sensiveis':{
#		'detection_upgrade' : 1.0,
#		'name':'antenas_sensiveis',
#	},
#	'olfato_preciso':{
#		'detection_food' : 1.0,
#		'name':'olfato_preciso',
#	},
#	'dentes_afiados':{
#		'drop_food' : 1.25,
#		'name':'dentes_afiados',
#	},
#	'glandula_sorte':{
#		'spawn_food' : 1.1,
#		'name':'glandula_sorte',
#	},
#	'bafo_fogo':{
#		'AoE_dmg_small' : 1.1,
#		'name':'bafo_fogo',
#	},
#	'vista_fria':{
#		'AoE_slow' : 0.9,
#		'name':'vista_fria',
#	},
	
}

var dictslots = {
	'menbros' : 3,
	'corpo' : 5,
}

var dict = {
	'menbros0': menbros.null,
	'menbros1': menbros.null,
	'menbros2': menbros.null,
	'corpo0': corpo.null,
	'corpo1': corpo.null,
	'corpo2': corpo.null,
	'corpo3': corpo.null,
	'corpo4': corpo.null,
#	'apendice0': apendice.null,
#	'apendice1': apendice.null,
#	'apendice2': apendice.null,
}

onready var dictbkp = dict
